#!/usr/bin/perl -w
#
#     File: postfix2protoserv
#     Author: Simone Marini - INFN - Pisa
#     Date: 10 April 2008
#     Purpose: Parse canonical and aliases and create input file for protoserv
#

use strict;

#if ( ! ( $ARGV[0] && $ARGV[1] ) ) {
#    die( "syntax: script canonical_filename aliases_filename domain" );
#}

my $canonical;
my $aliases;
my $utenti;
my $domain;

local *FILEUTENTI;
local *FILE1;
local *FILE2;
local *FILE3;

my $lineu;
my $line;
my $line2;
my $user;
my $canonicalname;
my $tempstr;
my $tempstr2;
my @listautenti;
my @list1;
my @list2;
my @listres;
my $tmpres;



( $utenti      = $ARGV[0] ) =~ s/\r?\n$//;
( $canonical   = $ARGV[1] ) =~ s/\r?\n$//;
( $aliases     = $ARGV[2] ) =~ s/\r?\n$//;
$domain      = $ARGV[3];


my $retvalu = open(FILEUTENTI, "<$utenti");
while ($lineu = readline(FILEUTENTI)) {
  ($lineu=$lineu) =~ s/\s{1,}/ /;
  ($lineu=$lineu) =~ s/\s$//;
#  ($lineu=$lineu) =~ s/\W//;
  $_=$lineu;
  if (/^(\w+)/){
    #print "$1\n";
    push(@listautenti,$1);
    }
  }
close FILEUTENTI;

#print @listautenti;


my $retval = open(FILE1, "<$canonical");
while ($line = readline(FILE1)) {
  ($line=$line) =~ s/\s{1,}/ /;
  ($line=$line) =~ s/\s$//;
  #print $line;
  push(@list1,$line);
  }
close FILE1;


my $retval2 = open(FILE2, "<$aliases");
while ($line2 = readline(FILE2)) {
  ($line2=$line2) =~ s/\s{1,}/ /;
  ($_=$line2) =~ s/\s$//;
  #print $line2;
  push(@list2,$line2);
  }
close FILE2;



foreach $user (@listautenti){
$tmpres=$user;
 #print "searching $user in aliases...\n";
 foreach $tempstr2 (@list2){
  #print "$tempstr2\n";
  if ($tempstr2 =~ /(.+\..+) $user$/){
   #print "found aliases $1\n";
   $canonicalname = $1;
   $tmpres = "$tmpres $1";
   
   foreach $tempstr (@list1){
    if ($tempstr =~ /^(.+) $canonicalname$/){
     if ($1 ne $user){ 
      $tmpres = "$tmpres $1";
      }
     }
    }
   } 
  } 


if ($tmpres ne $user){ 
push(@listres,"$tmpres $user");
      }
 
}

#exit;

print "\n";
print "Risultato finale:\n";
print "\n";

my $retval3 = open(FILE3, ">results.txt");

foreach $tmpres (@listres){
print "ADD $domain $tmpres\n";
print FILE3 "ADD $domain $tmpres\n";
}
close FILE3;
